package com.loafle.overflow.model.auth;

import com.loafle.overflow.model.meta.MetaCrawler;
import com.loafle.overflow.model.target.Target;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by geek on 17. 11. 7.
 */
@Entity
@Table(name = "AUTH_CRAWLER", schema = "public")
public class AuthCrawler {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_ID", nullable = false)
  private MetaCrawler metaCrawler;

  @ManyToOne
  @OnDelete(action = OnDeleteAction.CASCADE)
  @JoinColumn(name = "TARGET_ID", nullable = false)
  private Target target;

  @Column(name = "AUTH_JSON", nullable = false)
  private String authJson;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public MetaCrawler getMetaCrawler() {
    return metaCrawler;
  }

  public void setMetaCrawler(MetaCrawler metaCrawler) {
    this.metaCrawler = metaCrawler;
  }

  public Target getTarget() {
    return target;
  }

  public void setTarget(Target target) {
    this.target = target;
  }

  public String getAuthJson() {
    return authJson;
  }

  public void setAuthJson(String authJson) {
    this.authJson = authJson;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }
}
