package com.loafle.overflow.model.email;

import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.model.meta.MetaEmailType;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "EMAIL_AUTH", schema = "public")
public class EmailAuth {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @Basic
  @Column(name = "EMAIL_AUTH_KEY", nullable = true, length = 50)
  private String emailAuthKey;

  @Basic
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @Basic
  @Column(name = "AUTH_CONFIRM_DATE", nullable = true, insertable = true, updatable = true)
  private Date authConfirmDate;

  @ManyToOne
  @JoinColumn(name = "MEMBER_ID", nullable = false)
  private Member member;

  @ManyToOne
  @JoinColumn(name = "META_EMAIL_TYPE_ID", nullable = false)
  private MetaEmailType metaEmailType;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public String getEmailAuthKey() {
    return emailAuthKey;
  }

  public void setEmailAuthKey(String emailAuthKey) {
    this.emailAuthKey = emailAuthKey;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public Date getAuthConfirmDate() {
    return authConfirmDate;
  }

  public void setAuthConfirmDate(Date authConfirmDate) {
    this.authConfirmDate = authConfirmDate;
  }

  public Member getMember() {
    return member;
  }

  public void setMember(Member member) {
    this.member = member;
  }

  public MetaEmailType getMetaEmailType() {
    return metaEmailType;
  }

  public void setMetaEmailType(MetaEmailType metaEmailType) {
    this.metaEmailType = metaEmailType;
  }
}
