package com.loafle.overflow.model.infra;

import javax.persistence.*;

import com.loafle.overflow.model.meta.MetaPortType;

import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA_HOST_PORT", schema = "public")
public class InfraHostPort {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "INFRA_HOST_IP_ID", nullable = false)
  private InfraHostIP infraHostIP;

  @ManyToOne
  @JoinColumn(name = "META_PORT_TYPE_ID", nullable = true)
  private MetaPortType metaPortType;

  @Basic
  @Column(name = "PORT", nullable = true)
  private Integer port;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public InfraHostIP getInfraHostIP() {
    return infraHostIP;
  }

  public void setInfraHostIP(InfraHostIP infraHostIP) {
    this.infraHostIP = infraHostIP;
  }

  public MetaPortType getMetaPortType() {
    return metaPortType;
  }

  public void setMetaPortType(MetaPortType metaPortType) {
    this.metaPortType = metaPortType;
  }

  public Integer getPort() {
    return port;
  }

  public void setPort(Integer port) {
    this.port = port;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }
}
