package com.loafle.overflow.model.infra;

import javax.persistence.*;

import com.loafle.overflow.model.meta.MetaCryptoType;
import com.loafle.overflow.model.meta.MetaTargetServiceType;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "INFRA_SERVICE", schema = "public")
@DiscriminatorValue("3")
public class InfraService extends Infra {

  @ManyToOne
  @JoinColumn(name = "META_TARGET_SERVICE_TYPE_ID", nullable = true)
  private MetaTargetServiceType metaTargetServiceType;

  @OneToOne
  @JoinColumn(name = "INFRA_HOST_PORT_ID", nullable = true)
  private InfraHostPort infraHostPort;

  @ManyToOne
  @JoinColumn(name = "META_CRYPTO_TYPE_ID", nullable = true)
  private MetaCryptoType metaCryptoType;

  @Basic
  @Column(name = "DESCRIPTION", nullable = true, length = 500)
  private String description;

  public InfraService() {
    super();
  }

  public InfraService(Long id) {
    super(id);
  }

  public MetaTargetServiceType getMetaTargetServiceType() {
    return metaTargetServiceType;
  }

  public void setMetaTargetServiceType(MetaTargetServiceType metaTargetServiceType) {
    this.metaTargetServiceType = metaTargetServiceType;
  }

  public InfraHostPort getInfraHostPort() {
    return infraHostPort;
  }

  public void setInfraHostPort(InfraHostPort infraHostPort) {
    this.infraHostPort = infraHostPort;
  }

  public MetaCryptoType getMetaCryptoType() {
    return metaCryptoType;
  }

  public void setMetaCryptoType(MetaCryptoType metaCryptoType) {
    this.metaCryptoType = metaCryptoType;
  }

  /**
   * @return the description
   */
  public String getDescription() {
    return description;
  }

  /**
   * @param description the description to set
   */
  public void setDescription(String description) {
    this.description = description;
  }

}
