package com.loafle.overflow.model.member;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.loafle.overflow.model.meta.MetaMemberStatus;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by geek on 17. 11. 7.
 */
@Entity
@Table(name = "MEMBER", schema = "public")
public class Member {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @Basic
  @Column(name = "EMAIL", nullable = false, length = 50)
  private String email;

  @JsonIgnore
  @Basic
  @Column(name = "PW", nullable = true, length = 64)
  private String pw;

  @Basic
  @Column(name = "NAME", nullable = true, length = 50)
  private String name;

  @Basic
  @Column(name = "PHONE", nullable = true, length = 50)
  private String phone;

  @Basic
  @Column(name = "COMPANY_NAME", nullable = true, length = 50)
  private String companyName;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @ManyToOne
  @JoinColumn(name = "META_MEMBER_STATUS_ID", nullable = false)
  private MetaMemberStatus metaMemberStatus;

  @Column(name = "SIGNIN_FAIL_COUNT", nullable = true, columnDefinition = "int default 0")
  private Integer signinFailCount;

  @Basic
  @Column(name = "TOTP_TYPE", nullable = false, columnDefinition = "Boolean default false")
  private Boolean totpType;

  public Member() {
  }

  public Member(Long id) {
    this.id = id;
  }

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public String getPw() {
    return pw;
  }

  public void setPw(String pw) {
    this.pw = pw;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getPhone() {
    return phone;
  }

  public void setPhone(String phone) {
    this.phone = phone;
  }

  public String getCompanyName() {
    return companyName;
  }

  public void setCompanyName(String companyName) {
    this.companyName = companyName;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public MetaMemberStatus getMetaMemberStatus() {
    return metaMemberStatus;
  }

  public void setMetaMemberStatus(MetaMemberStatus metaMemberStatus) {
    this.metaMemberStatus = metaMemberStatus;
  }

  public Integer getSigninFailCount() {
    return this.signinFailCount;
  }

  public void setSigninFailCount(Integer failCount) {
    this.signinFailCount = failCount;
  }

  public Boolean isTotpType() {
    return totpType;
  }

  public void setTotpType(Boolean totpType) {
    this.totpType = totpType;
  }
}
