package com.loafle.overflow.model.meta;

import java.util.Date;

import javax.persistence.*;

/**
 * Created by snoop on 18. 4. 24.
 */
@Entity
@Table(name = "META_CRAWLER_MAPPING", schema = "public")
public class MetaCrawlerMapping {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "META_TARGET_TYPE_ID", nullable = false)
  private MetaTargetType metaTargetType;

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_ID", nullable = false)
  private MetaCrawler metaCrawler;

  @Column(name = "DEFAULT_INTERVAL", nullable = false)
  private Integer defaultInterval;

  @Column(name = "IS_DEFAULT", nullable = false, columnDefinition = "Boolean default false")
  private Boolean isDefault;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  @ManyToOne
  @JoinColumn(name = "META_CRAWLER_CONTAINER_ID", nullable = false)
  private MetaCrawlerContainer metaCrawlerContainer;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public MetaTargetType getMetaTargetType() {
    return metaTargetType;
  }

  public void setMetaTargetType(MetaTargetType metaTargetType) {
    this.metaTargetType = metaTargetType;
  }

  public MetaCrawler getMetaCrawler() {
    return metaCrawler;
  }

  public void setMetaCrawler(MetaCrawler metaCrawler) {
    this.metaCrawler = metaCrawler;
  }

  public Integer getDefaultInterval() {
    return defaultInterval;
  }

  public void setDefaultInterval(Integer defaultInterval) {
    this.defaultInterval = defaultInterval;
  }

  public Boolean getDefault() {
    return isDefault;
  }

  public void setDefault(Boolean aDefault) {
    isDefault = aDefault;
  }

  public MetaCrawlerContainer getMetaCrawlerContainer() {
    return metaCrawlerContainer;
  }

  public void setMetaCrawlerContainer(MetaCrawlerContainer metaCrawlerContainer) {
    this.metaCrawlerContainer = metaCrawlerContainer;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

}
