package com.loafle.overflow.model.meta;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "META_MEMBER_STATUS", schema = "public")
public class MetaMemberStatus {

  @Id
  private Short id;

  @Column(name = "KEY", nullable = true, length = 50)
  private String key;

  @Column(name = "Name", nullable = false, length = 100)
  private String name;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  public MetaMemberStatus() {

  }

  public MetaMemberStatus(Short id) {
    this.id = id;
  }

  public Short getId() {
    return id;
  }

  public void setId(Short id) {
    this.id = id;
  }

  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public static enum Enum {
    NOAUTH((short) 1), NORMAL((short) 2), DORMANCY((short) 3), WITHDRAWAL((short) 4),;

    private final Short value;

    /**
     * @param value
     */
    Enum(final Short value) {
      this.value = value;
    }

    public Short getValue() {
      return this.value;
    }

    public MetaMemberStatus to() {
      return new MetaMemberStatus(this.value);
    }
  }
}
