package com.loafle.overflow.model.probe;

import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.model.meta.MetaProbeStatus;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "PROBE", schema = "public")
public class Probe {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "META_PROBE_STATUS_ID", nullable = false)
  private MetaProbeStatus metaProbeStatus;

  @Column(name = "DESCRIPTION", nullable = true, length = 50)
  private String description;

  @ManyToOne
  @JoinColumn(name = "DOMAIN_ID", nullable = false)
  private Domain domain;

  @Column(name = "PROBE_KEY", nullable = false, unique = true)
  private String probeKey;

  @Column(name = "ENCRYPTION_KEY", nullable = false, length = 100, unique = true)
  private String encryptionKey;

  @Column(name = "NAME", nullable = false, length = 50)
  private String name;

  @Column(name = "CIDR")
  private String cidr;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "AUTHORIZE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date authorizeDate;

  @ManyToOne
  @JoinColumn(name = "AUTHORIZE_MEMBER_ID", nullable = false)
  private Member authorizeMember;

  @Column(name = "TARGET_COUNT", nullable = false)
  private Integer targetCount;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CONNECT_DATE", nullable = true)
  private Date connectDate;

  @Column(name = "CONNECT_ADDRESS", nullable = true, length = 50)
  private String connectAddress;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  public Probe() {

  }

  public Probe(Long id) {
    this.id = id;
  }

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public MetaProbeStatus getMetaProbeStatus() {
    return metaProbeStatus;
  }

  public void setMetaProbeStatus(MetaProbeStatus metaProbeStatus) {
    this.metaProbeStatus = metaProbeStatus;
  }

  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public Domain getDomain() {
    return domain;
  }

  public void setDomain(Domain domain) {
    this.domain = domain;
  }

  public String getProbeKey() {
    return probeKey;
  }

  public void setProbeKey(String probeKey) {
    this.probeKey = probeKey;
  }

  public String getEncryptionKey() {
    return encryptionKey;
  }

  public void setEncryptionKey(String encryptionKey) {
    this.encryptionKey = encryptionKey;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getCidr() {
    return cidr;
  }

  public void setCidr(String cidr) {
    this.cidr = cidr;
  }

  public Date getAuthorizeDate() {
    return authorizeDate;
  }

  public void setAuthorizeDate(Date authorizeDate) {
    this.authorizeDate = authorizeDate;
  }

  public Member getAuthorizeMember() {
    return authorizeMember;
  }

  public void setAuthorizeMember(Member authorizeMember) {
    this.authorizeMember = authorizeMember;
  }

  public Integer getTargetCount() {
    return targetCount;
  }

  public void setTargetCount(Integer targetCount) {
    this.targetCount = targetCount;
  }

  public Date getConnectDate() {
    return connectDate;
  }

  public void setConnectDate(Date connectDate) {
    this.connectDate = connectDate;
  }

  public String getConnectAddress() {
    return connectAddress;
  }

  public void setConnectAddress(String connectAddress) {
    this.connectAddress = connectAddress;
  }

  @PrePersist
  void preInsert() {
    this.targetCount = 0;
  }

}
