package com.loafle.overflow.model.sensor;

import com.loafle.overflow.model.meta.MetaDisplayItemMapping;
import org.hibernate.annotations.OnDelete;
import org.hibernate.annotations.OnDeleteAction;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "SENSOR_ITEM", schema = "public")
public class SensorItem {

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;

  @ManyToOne
  @JoinColumn(name = "SENSOR_ID", nullable = false)
  @OnDelete(action = OnDeleteAction.CASCADE)
  private Sensor sensor;

  @ManyToOne
  @JoinColumn(name = "META_DISPLAY_ITEM_MAPPING_ID", nullable = false)
  private MetaDisplayItemMapping metaDisplayItemMapping;

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  private Date createDate;

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public Sensor getSensor() {
    return this.sensor;
  }

  public void setSensor(Sensor sensor) {
    this.sensor = sensor;
  }

  public MetaDisplayItemMapping getMetaDisplayItemMapping() {
    return metaDisplayItemMapping;
  }

  public void setMetaDisplayItemMapping(MetaDisplayItemMapping metaDisplayItemMapping) {
    this.metaDisplayItemMapping = metaDisplayItemMapping;
  }

  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

}
