package com.loafle.overflow.model.sensorconfig.old;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * ResultSetCol
 */
public class ResultSetCol extends ResultSet {

  public ResultSetCol(Item item) {
    super(item);
  }

  public void setMeta() {
    List<Keys> meta = this.item.getKeys();
    List<String> arrayColumns = this.item.getMappingInfo().getArrayColumns();

    if (this.meta == null) {
      this.meta = new HashMap<>();
    }

    for (int indexI = 0; indexI < meta.size(); ++indexI) {
      this.meta.put(meta.get(indexI).getKey(), indexI);
    }

    if (arrayColumns != null) {
      for (int indexI = 0; indexI < arrayColumns.size(); ++indexI) {
        if (this.meta.containsKey(arrayColumns.get(indexI))) {
          continue;
        }
        this.meta.put(arrayColumns.get(indexI), indexI + meta.size());
      }
    }

  }

  public Map<String, String> parse() {

    List<Keys> metrics = this.item.getKeys();
    List<String> arrayColumns = this.item.getMappingInfo().getArrayColumns();

    Map<String, String> resultMap = new HashMap<>();

    List<String> row = null;

    String metric = null;
    List<String> arrayValue = new ArrayList<>();

    int columnIdx = 0;

    for (int indexI = 0; indexI < this.rows.size(); ++indexI) {

      row = this.rows.get(indexI);
      for (int indexJ = 0; indexJ < row.size(); ++indexJ) {

        arrayValue.clear();

        if (arrayColumns != null) {
          for (int indexL = 0; indexL < arrayColumns.size(); ++indexL) {
            columnIdx = this.meta.get(arrayColumns.get(indexL));

            arrayValue.add(row.get(columnIdx));
          }
        }

        for (int indexK = 0; indexK < metrics.size(); ++indexK) {
          metric = metrics.get(indexK).getMetric();
          metric = convertMetric(metric, arrayValue);
          resultMap.put(metric, row.get(indexK));
        }

      }

    }

    return resultMap;

  }

  private String convertMetric(String metric, List<String> arrayValue) {

    if (arrayValue == null || arrayValue.size() <= 0) {
      return metric;
    }

    String convertChar = "$";
    String convertStr = null;

    for (int indexI = 0; indexI < arrayValue.size(); ++indexI) {

      convertStr = convertChar + String.valueOf(indexI);

      metric = metric.replace(convertStr, arrayValue.get(indexI));

    }

    return metric;
  }
}
